package com.sensorsystem1.nfc;

/* Used From Android NFC Advance 
 * 
 * http://developer.android.com/reference/android/nfc/NfcAdapter.html#enableForegroundDispatch%28android.app.Activity,%20android.app.PendingIntent,%20android.content.IntentFilter[],%20java.lang.String[][]%29
 * 
 */

/// IsoDep, NfcB, Ndef
import android.nfc.Tag;
import android.nfc.tech.IsoDep;
import android.nfc.tech.MifareUltralight;
import android.util.Log;
import java.io.IOException;
import java.nio.charset.Charset;

public class NFC {

	private static final String TAG = NFC.class.getSimpleName();

	public void writeTag(Tag tag, String tagText) {
		MifareUltralight ultralight = MifareUltralight.get(tag);
		try {
			ultralight.connect();
			ultralight.writePage(4,
					"abcd".getBytes(Charset.forName("US-ASCII")));
			ultralight.writePage(5,
					"efgh".getBytes(Charset.forName("US-ASCII")));
			ultralight.writePage(6,
					"ijkl".getBytes(Charset.forName("US-ASCII")));
			ultralight.writePage(7,
					"mnop".getBytes(Charset.forName("US-ASCII")));
		} catch (IOException e) {
			Log.e(TAG, "IOException while closing MifareUltralight...", e);
		} finally {
			try {
				ultralight.close();
			} catch (IOException e) {
				Log.e(TAG, "IOException while closing MifareUltralight...", e);
			}
		}
	}

	public String readTag(Tag tag) {
		IsoDep mifare = IsoDep.get(tag);

		byte[] SELECT = { (byte) 0x00, // CLA Class
				(byte) 0xB0, // INS Instruction
				(byte) 0x00, // P1 Parameter 1
				(byte) 0x00, // P2 Parameter 2
				(byte) 0xFF // LE maximal number of bytes expected in result
		};

		byte[] result = null;
		String decoded = null;
		try {
			mifare.connect();

			result = mifare.transceive(SELECT);
			decoded = new String(result, "UTF_8");
			System.out.println("TESTING" +decoded);
			String[] temp = decoded.split("en");
			temp = temp[1].trim().split(" ");
			decoded = temp[0] + " " +temp[1];
			System.out.println("TESTING" +decoded);
//			System.out.println(result);
//			System.out.println(decoded);
			
		} catch (IOException e) {
			Log.e(TAG, "IOException while writing MifareUltralight message...",
					e);
		} finally {
			if (mifare != null) {
				try {
					mifare.close();
				} catch (IOException e) {
					Log.e(TAG, "Error closing tag...", e);
				}
			}
		}

		return decoded.toString();
	}

	// // MifareUltralight mifare = MifareUltralight.get(tag);
	// try {
	// mifare.connect();
	// for(int i = 4; i<17; i=i+4){
	// System.out.println(i + " Hi " + new String(mifare.readPages(i),
	// Charset.forName("US-ASCII")));
	// }
	// byte[] payload = mifare.;
	// return new String(payload, Charset.forName("US-ASCII"));
	// } catch (IOException e) {
	// Log.e(TAG, "IOException while writing MifareUltralight message...", e);
	// } finally {
	// if (mifare != null) {
	// try {
	// mifare.close();
	// }
	// catch (IOException e) {
	// Log.e(TAG, "Error closing tag...", e);
	// }
	// }
	// }
	// return null;
	// }
	
	
}